## Disable milter for now...
%define MILTER_PACKAGE	1

%define username	clamav
%define homedir		%{_var}/lib/clamav
%define freshclamlog	%{_var}/log/clamav-update
%define clamdlog	%{_var}/log/clamd
%define milterlog	%{_var}/log/clamd-milter
%define clamdstatedir	%{_localstatedir}/run/clamd
%define milterstatedir	%{_localstatedir}/run/clamav-milter
%define milterhome	%{_localstatedir}/lib/clamav-milter

Summary:	End-user tools for the Clam Antivirus scanner
Name:		clamav
Version:	0.88.3
Release:	1
Epoch:		0
License:	GPL
Group:		Applications/File
URL:		http://www.clamav.net
Source0:	http://download.sourceforge.net/sourceforge/clamav/%{name}-%{version}.tar.gz
Source1:	clamd.sysconfig
Source2:	clamd.logrotate
#Source3:	clamav-sockwrite.c
Source4:	clamav-update.logrotate
Source5:	clamav-notify-servers
Patch21:	clamav-init-redhat.patch
Patch22:	clamav-milter-init-redhat.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
Requires(pre,postun):	/etc/cron.d
Requires(post):		%{__chown} %{__chmod}
BuildRequires:	zlib-devel bzip2-devel gmp-devel
#BuildRequires:	dietlibc
#Obsoletes:	clamav-lib clamav-data clamav-update clamav-server
Obsoletes:	clamav-lib clamav-data clamav-update 

%package devel
Summary:        Header files and libraries for the Clam Antivirus scanner
Group:          Development/Libraries
#Source100:      clamd-gen
Requires(pre):  %_libdir/pkgconfig

%package server
Summary:        Clam Antivirus scanner server
Group:          System Environment/Daemons
Provides:       clamav-daemon = %{version}-%{release}
Obsoletes:      clamav-daemon < %{version}-%{release}
Conflicts:      clamav-daemon > %{version}-%{release}
## For now, use this as a placeholder. Later, generate separate -sysv
## and -minit subpackages
Requires:       init(clamav-server)
Provides:       init(clamav-server) = sysv
Requires(pre):          %_initrddir
Requires(postun):       %_initrddir

%if %{MILTER_PACKAGE}
%package milter
Summary:	A sendmail-milter for clamav
Group:		System Environment/Daemons
## For now, use this as a placeholder. Later, generate separate -sysv
## and -minit subpackages
Requires:	init(clamav-milter)
Provides:	init(clamav-milter)
Requires:	clamav = %{epoch}:%{version}-%{release}
Requires:	sendmail >= 8.12
Requires:	sendmail-cf >= 8.12
Requires:	tcp_wrappers
BuildRequires:	sendmail-devel >= 8.12
BuildRequires:	tcp_wrappers
Requires(post,preun):	chkconfig
Requires(preun,postun):	initscripts
%endif

%description
Clam AntiVirus is an anti-virus toolkit for UNIX. The main purpose of this
software is the integration with mail servers (attachment scanning). The
package provides a flexible and scalable multi-threaded daemon, a command
line scanner, and a tool for automatic updating via Internet. The programs
are based on a shared library distributed with the Clam AntiVirus package,
which you can use with your own software. The virus database is based on
the virus database from OpenAntiVirus, but contains additional signatures
(including signatures for popular polymorphic viruses, too) and is KEPT UP
TO DATE.

%description devel
This package contains headerfiles and libraries which are needed to
build applications using clamav.

%description server
ATTENTION: most users do not need this package; the main package has
everything (or depends on it) which is needed to scan for virii on
workstations.

%if %{MILTER_PACKAGE}
%description milter
ClamAV sendmail filter using MILTER interface.

THIS PACKAGE IS TO BE CONSIDERED AS EXPERIMENTAL!
%endif

## ------------------------------------------------------------

%prep
%setup -q -n clamav-%{version}
%patch21 -p0
%patch22 -p0

perl -pi -e 's!^(Example).*!#\1!g;
            s!^#?(LogFile ).*!\1/var/log/clamd!g;
            s!^#?(LogTime).*!\1!g;
            s!^#?(PidFile ).*!\1/var/run/clamd.pid!g;
            s!^#?(LocalSocket ).*!\1/var/run/clamd/clamd.sock!g;
            s!^#?(User ).*!User clamav!g;
            s!^#?(ScanPE).*!\1!g;
            s!^#?(ScanOLE2).*!\1!g;
            s!^#?(ScanMail).*!\1!g;
            s!^#?(ScanHTML).*!\1!g;
            s!^#?(ScanArchive).*!\1!g;
            s!^#?(ScanRAR).*!\1!g;
            ' etc/clamd.conf

perl -pi -e 's!^(Example).*!#\1!g;
             s!^#(MaxAttempts) .*!\1 5!g;
             s!^#(DNSDatabaseInfo) .*!\1 current.cvd.clamav.net!;
             s!^#(Checks) .*!\1 24!g;
            ' etc/freshclam.conf

## ------------------------------------------------------------

%build
#%%configure --disable-clamav --with-dbdir=/var/lib/clamav
## The %%configure macro can not be used since the script breaks on
## the old architecture specification

CFLAGS=$RPM_OPT_FLAGS; export CFLAGS
./configure --prefix=%{_prefix} --mandir=%{_mandir} \
        --sysconfdir=%{_sysconfdir} \
        --enable-dns \
        --enable-id-check \
	--disable-clamav --with-dbdir=%{homedir} \
	--with-user=clamav \
	--with-group=clamav \
        --disable-zlib-vcheck \
%if %MILTER_PACKAGE
	--enable-milter
%endif

#diet -Os %{__cc} $RPM_OPT_FLAGS %{SOURCE3} -o clamav-sockwrite
%{__make} %{?_smp_mflags}


## ------------------------------------------------------------

%install
rm -rf "$RPM_BUILD_ROOT" _doc*
%{__make} DESTDIR="$RPM_BUILD_ROOT" install

%{__install} -d ${RPM_BUILD_ROOT}%{_sysconfdir}/{clamd.d,cron.d,logrotate.d,sysconfig} \
		${RPM_BUILD_ROOT}%{_var}/log \
		${RPM_BUILD_ROOT}{%{clamdstatedir},%{milterstatedir},%{milterhome}} \
		${RPM_BUILD_ROOT}%{_initrddir}

rm -rf ${RPM_BUILD_ROOT}%{_libdir}/*.la

## prepare the server-files
#%{__install} -m755 -p clamav-sockwrite 	${RPM_BUILD_ROOT}%{_sbindir}/
%{__install} -m644 -p %{SOURCE1}	${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/clamd
%{__install} -m644 -p %{SOURCE2}       	${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/clamd

%{__install} -p -m755 contrib/init/RedHat/clamd $RPM_BUILD_ROOT%{_initrddir}/clamd

## prepare the update-files
%{__install} -m644 -p %{SOURCE4}	${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/clamav-update
%{__install} -m755 -p %{SOURCE5}	${RPM_BUILD_ROOT}%{_sbindir}/clamav-notify-servers
touch ${RPM_BUILD_ROOT}%{freshclamlog}

cat >${RPM_BUILD_ROOT}%{_sysconfdir}/cron.d/clamav-update <<EOF
# http_proxy=http://www-cache:3128
3 */4 * * * %{username} %{_bindir}/freshclam --quiet -l %{freshclamlog} && { test -x %{_sbindir}/clamav-notify-servers && exec %{_sbindir}/clamav-notify-servers || :; }
EOF

#### The milter stuff

%if %{MILTER_PACKAGE}
cat >$RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/clamav-milter <<EOF
CLAMAV_FLAGS="--config-file=%{_sysconfdir}/clamav-milter.conf --max-children=10 --dont-wait -N -ol local:%{milterstatedir}/milter.sock"
CLAMAV_USER=%{username}
EOF

sed -e 's!^#User .*!User %{username}!;
	s!^#PidFile .*!PidFile %{milterstatedir}/clamav-milter.pid!;
        s!^#ScanPE!ScanPE!g;
        s!^#ScanOLE2!ScanOLE2!g;
	s!^#ScanMail!ScanMail!;
	s!^#ScanHTML!ScanHTML!;
        s!^#ScanArchive!ScanArchive!g;
        s!^#ScanRAR!ScanRAR!g;
	s!^LocalSocket .*!LocalSocket %{clamdstatedir}/clamd.sock!;' \
	etc/clamd.conf >$RPM_BUILD_ROOT%{_sysconfdir}/clamav-milter.conf

%{__install} -p -m755 contrib/init/RedHat/clamav-milter $RPM_BUILD_ROOT%{_initrddir}/clamav-milter

touch $RPM_BUILD_ROOT%{milterstatedir}/{clamd.sock,clamav-milter.pid,milter.sock}
%endif

## ------------------------------------------------------------

%check || :
grep -r "$RPM_BUILD_ROOT" $RPM_BUILD_ROOT && exit 1 || :

%clean
rm -rf "$RPM_BUILD_ROOT"

## ------------------------------------------------------------

%pre
if [ -z "`/usr/bin/id -g clamav 2>/dev/null`" ]; then
	/usr/sbin/groupadd -g 46 -r -f %{username} 2>&1 || :
fi
if [ -z "`/usr/bin/id -u clamav 2>/dev/null`" ]; then
	/usr/sbin/useradd -u 46 -r -M -d %{homedir} -s /sbin/nologin \
             -c "Clam AntiVirus" -g %{username} %{username} 2>&1 || :
fi

%post
/sbin/ldconfig
test -e %{freshclamlog} || touch %{freshclamlog}
%{__chmod} 0600 %{freshclamlog}
%{__chown} %{username}.%{username} %{freshclamlog}

%post server
/sbin/chkconfig --add clamd
test -e %{clamdlog} || touch %{clamdlog}
%{__chmod} 0600 %{clamdlog}
%{__chown} %{username}.%{username} %{clamdlog}

%postun
/sbin/ldconfig
if [ $1 -eq 0 ]; then
  /usr/sbin/userdel clamav > /dev/null 2>&1
  /usr/sbin/groupdel clamav > /dev/null 2>&1
fi
if [ $1 -ge 1 ]; then
  /sbin/service clamd condrestart
fi

%preun server
if [ $1 -eq 0 ]; then
  /sbin/service clamd stop > /dev/null 2>&1
  /sbin/chkconfig --del clamd
fi

%if %{MILTER_PACKAGE}

%post milter
/sbin/chkconfig --add clamav-milter

%preun milter
if [ $1 -eq 0 ]; then
  /sbin/service clamav-milter stop > /dev/null 2>&1
  /sbin/chkconfig --del clamav-milter
fi

%postun milter
/sbin/ldconfig
if [ $1 -ge 1 ]; then
  /sbin/service clamav-milter condrestart
fi

%endif


%files
%defattr(-,root,root,-)
%doc AUTHORS BUGS COPYING ChangeLog FAQ NEWS README TODO UPGRADE
%doc docs/*.pdf
%doc %{_mandir}/man1/clamscan.*
%doc %{_mandir}/man1/clamdscan.*
%doc %{_mandir}/man1/sigtool.*
%doc %{_mandir}/man[15]/freshclam*
#%doc %{_mandir}/man[58]/clamd*
%{_bindir}/*
%exclude %_bindir/clamav-config
%{_libdir}/*.so.*
#%{_sbindir}/clamd
#%{_sbindir}/clamav-notify-servers
#%{_sbindir}/clamav-sockwrite
#%config %{_initrddir}/clamd
#%config %{_sysconfdir}/clamd.conf
#%config %{_sysconfdir}/sysconfig/clamd
%attr(0755,%{username},%{username}) %dir %{homedir}
%attr(0755,%{username},%{username}) %config(noreplace) %verify(not size md5 mtime) %{homedir}/*.cvd
%config(noreplace) %{_sysconfdir}/cron.d/*
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%config(noreplace) %{_sysconfdir}/freshclam.conf
%ghost %attr(0664,root,%{username}) %verify(not size md5 mtime) %{freshclamlog}
%attr(0755,%{username},%{username}) %dir %{clamdstatedir}


## -----------------------

%files devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.*a
%{_libdir}/*.so
#%dir %pkgdatadir
#%pkgdatadir/template
#%pkgdatadir/clamd-gen
%_libdir/pkgconfig/*
%_bindir/clamav-config

## -----------------------

%files server
%defattr(-,root,root,-)
#%doc _doc_server/*
%doc %_mandir/*/clamd*
%{_sbindir}/*
%_initrddir/clamd
#%dir %pkgdatadir
%config %{_sysconfdir}/clamd.conf
%config %{_sysconfdir}/sysconfig/clamd

## -----------------------

%if %{MILTER_PACKAGE}
%files milter
%defattr(-,root,root,-)
%doc %{_mandir}/man8/clamav-milter.*
%{_sbindir}/clamav-milter
%config %{_initrddir}/clamav-milter
%config(noreplace) %{_sysconfdir}/clamav-milter.conf
%config(noreplace) %{_sysconfdir}/sysconfig/clamav-milter
%attr(0750,%{username},%{username}) %{milterhome}
%attr(0700,%{username},%{username}) %dir %{milterstatedir}
%ghost %{milterstatedir}/*
%endif

%changelog
* Sun Jul  2 2006 TSUCHIDA Fumitaka <builder at agentlab.jp> (0.88.3-1)
- Update to 0.88.3

* Mon May  1 2006 TSUDA Fumika <builder@fumika.jp> (0.88.2-1)
- Update to 0.88.2

* Wed Apr  5 2006 TSUDA Fumika <builder@fumika.jp> (0.88.1-1)
- Update to 0.88.1

* Tue Jan 10 2006 TSUDA Fumika <builder@fumika.jp> (0.88-1)
- Update to 0.88

* Sat Nov  4 2005 TSUDA Fumika <builder@fumika.jp> (0.87.1-1)
- Update to 0.87.1

* Sat Sep 17 2005 TSUDA Fumika <builder@fumika.jp> (0.87-1)
- Update to 0.87

* Mon Jul 25 2005 TSUDA Fumika <builder@fumika.jp> (0.86.2)
- Update to 0.86.2

* Fri Jun 24 2005 TSUDA Fumika <builder@fumika.jp> (0.86.1)
- Update to 0.86.1

* Tue Jun 21 2005 TSUDA Fumika <builder@fumika.jp> (0.86)
- Update to 0.86

* Tue May 17 2005 TSUDA Fumika <builder@fumika.jp> (0.85.1-2)
- Fix param 'restart' to 'condrestart' in %postun scripts 

* Tue May 17 2005 TSUDA Fumika <builder@fumika.jp> (0.85.1-1)
- Update to 0.85.1
- Fix %preun %postun scripts

* Fri May 13 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.85
- Fix mode, group of clamd logfile
- Change milteruser from 'clamilt' to 'clamav'
- Not use fedora-usermgmt package

* Sat Apr 30 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.84

* Mon Feb 14 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.83

* Mon Feb 07 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.82

* Sun Jan 30 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.81
- Add -i-enable-dns --enable-id-check configure options.
- Add --max-children --dont-wait option to /etc/sysconfig/clamav-milter
- Fix DNSDatabaseInfo to default in freshclam.conf

* Thu Jan 20 2005 TSUDA Fumika <builder@fumika.jp>
- Update to 0.81rc1

* Mon Oct 18 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.80

* Tue Oct 12 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.80rc4

* Wed Sep 29 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.80rc3

* Wed Sep 22 2004 TSUDA Fumika <builder@fumika.jp>
- Fix chkconfig in %post and %preun

* Wed Sep 22 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.80rc2

* Tue Sep 21 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.80rc
- Rename clamav.conf to clamd.conf
- Remove some document files.
- Remove StreamSaveToDisk in clamd.conf

* Wed Aug 11 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.75.1

* Mon Jun 15 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.73

* Mon Jun  7 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.72

* Mon May 24 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.71

* Mon Apr 26 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.70
- Change "clamd.<SERVICE>" to "clamd"

* Thu Mar 18 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.68-1

* Tue Mar 16 2004 TSUDA Fumika <builder@fumika.jp>
- Update to 0.68
- remove mirrors.txt, add freshclam.conf

* Wed Feb 04 2004 TSUDA Fumika <builder@fumika.jp>
- 0.65 for Red Hat 9.0 with clamav-milter

* Fri Nov 28 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.65-0.fdr.4
- fixed typo in README (sysconf.d vs. sysconf)
- make build on rhl8 succeed by adding '|| :' to %%check

* Tue Nov 18 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.65-0.fdr.3
- substitute 'User' in sample cfg-file also
- uncommented some cfg-options which are needed for a proper operation
- fixed typos in README (thanks to Michael Schwendt)

* Mon Nov 17 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.65-0.fdr.2
- fixed path of 'LocalSocket' and documented steps how to create it
- added a missing backslash at the configure-call
- do not package clamav-milter.8 manpage
- documented 'User' in the README

* Sat Nov 15 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.65-0.fdr.1
- updated to 0.65
- added gmp-devel buildrequires:
- changed installed databases from 'viruses.db*' to '*.cvb'
- made milter-build conditional; 0.65 is missing some files which would break the build else
- fixed typo (clamav-notify-server -> clamav-notify-servers)

* Fri Oct 31 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.60-0.fdr.5
- created -update subpackage and filled it with files from main and -data package
- set more reasonable default-values in the sample config-file
- made the README in -server more clear
- moved clamav-milter man-page into -milter subpackage
- use fedora-usermgmt
- renamed -daemon subpackage and related files to -server
- use abstract 'data(clamav)' notation for clamav-data dependencies
- use 'init(...)' requirements as placeholder for future -sysv/-minit subpackages

* Sat Aug 16 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.4
- backported clamav-sockwrite.c to C89

* Fri Aug 15 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.3
- updated Source0 URL
- fixed portuguese i18n-abbreviation

* Fri Jul 18 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.3
- use LSB compliant exit-codes in the init-script
- other init-script cleanups

* Tue Jul 15 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.2
- updated %%description
- removed README from %%doc-list

* Thu Jun 26 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.1
- disabled -milter subpackage; I do not get it to run :(

* Thu Jun 26 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.60-0.fdr.0.1
- updated to 0.60
- modernized usercreation
- added -milter subpackage

* Thu May  8 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.54-0.fdr.2
- added BUGS file
- moved clamd.8 man-page into daemon-subpackage
- some cosmetical cleanups
- removed config-patch; it was unused
- made some paths more fedora-compliant
- honor $RPM_OPT_FLAGS
- added clamav-notify-daemons script
- removed obsoleted %%socketdir

* Wed May  7 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.54-0.fdr.0.1
- splitted into additional -data/-daemon packages
- added clamav-sockwrite program
- updated to recent fedora policies

* Thu Nov 21 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.54-1
- updated to 0.54
- updated config-patch

* Tue Oct 29 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.52-1
- updated to 0.52

* Tue Sep 17 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 
- Initial build.
